library BasePlugin;

uses
  Sharemem,
  SysUtils,
  Classes,
  tasmovies;

type
  header = record
    gmv      : array[0..14] of char;
    ver      : byte;
    rerecs   : longword;
    pc       : array[0..1] of char;
    flags    : word;
    desc     : array[0..39] of char;
  end;

{$R *.res}

const
  chars='^v<>ABCSXYZM';
//  chars='xxxxyyyyRL123456';
  headnum = 6;
  names : array[0..headnum-1] of string =
    ('','','','','','');
  types : array[0..headnum-1] of byte = // type: 0 = signed, 1 = unsigned, 2 = flags, 3 = string
    (0,0,0,0,0,0);
  sizes : array[0..headnum-1] of integer =
    (0,0,0,0,0,0);

Procedure GetInfo (ext, desc : pchar);
begin
  strcopy(ext,'gmv');
  strcopy(desc,'Gens movie (beta)');
end;

Procedure LoadMovie (var data: TMovie; const fn: pchar; res:pchar);
var
  F : file of char;
  fnn :string;
  s,nam : string;
  h : header;
  n : integer;
  cdata : array of array [0..2] of byte;
  dt : array[0..sizeof(header)-1] of byte;
begin
data.error := 1;
getmem(data.filename, strlen(fn)+1);
strcopy(data.filename,fn);
data.headers := 0;
data.frames := 0;
data.datastart := 0;
data.controllers := 0;
data.fragments := 0;
setlength(data.header,0);
setlength(data.controller,0);
setlength(data.fragment,0);
fillchar(dt,sizeof(h),0);
//let's go
data.controllers := 1;
fnn := fn;
assign(f,fnn); reset(f);
if filesize(f) < sizeof(h) then
begin
  strcopy(res,'Too small file');
  close(f); exit;
end;
blockread(f,h,sizeof(h));

if h.gmv <> 'Gens Movie TEST' then
begin
  strcopy(res,pchar('Wrong header'));
  close(f); exit;
end;
data.headers := 24;
setlength(data.header,data.headers);
//    GMV      : array[0..14] of char;
n := 0;
getmem(data.header[0].name,7);
strcopy(data.header[0].name, 'header');
getmem(data.header[0].sdata,16);
strcopy(data.header[0].sdata, pchar(string(h.gmv)+#0));
data.header[0].tp := 3;
data.header[0].l := 15;
data.header[0].Idata := 0;
//    ver      : longword;
inc(n); nam := 'Version';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.ver);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 0;
data.header[n].l := 1;
data.header[n].Idata := h.ver;
//    rerecs   : longword;
inc(n); nam := 'Rerecordings';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.rerecs);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.rerecs;
//    fps      : byte;
{inc(n); nam := 'FPS';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.fps);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 1;
data.header[n].Idata := h.contrnum;}
//    contrnum : byte;
{inc(n); nam := 'Controllers';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.rerecs);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 1;
data.header[n].Idata := h.contrnum;}
//
inc(n); nam := 'Special Flags';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.flags);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 2;
data.header[n].Idata := h.flags;
//    player 1 mode
inc(n); nam := 'Player 1 mode (3/6)';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := h.pc[0];
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 3;
data.header[n].l := length(s);
//    player 2 mode
inc(n); nam := 'Player 2 mode (3/6)';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := h.pc[1];
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 3;
data.header[n].l := length(s);
//    desc     : array[0..39] of char;
inc(n); nam := 'Description';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := h.desc;
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 3;
data.header[n].l := length(s);
//    gamecode     : array[0..255] of char;
inc(n); nam := 'Controller codes';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := chars;
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 3;
data.header[n].l := length(s);
//on for the movie
data.frames := (filesize(f)-64) div 3-1;
setlength(cdata,data.frames);
data.controllers := 2;
setlength(data.controller,2);
setlength(data.controller[0].data,data.frames+1);
setlength(data.controller[1].data,data.frames+1);
blockread(f,cdata[0],(data.frames+1) * 3);
for n := 0 to data.frames do
begin
  data.controller[0].data[n] := ((cdata[n][0] and $ff) or ((cdata[n][2] and $0F) shl 8)) xor $FFF;
  data.controller[1].data[n] := ((cdata[n][1] and $ff) or ((cdata[n][2] and $F0) shl 4)) xor $FFF;
end;
close(f);
data.error := 0;
end;

Procedure SaveMovie (const data: TMovie; const fn: pchar; res:pchar);
//{
var
  f : file of byte;
  fnn : string;
  cdata : array of array[0..2] of byte;
  a : integer;
  h : header;//}
begin
//{
  fillchar(h,sizeof(h),0);
  fnn := fn;
  assign(f,fnn); rewrite(f);
  //header
//    pc       : array[0..1] of char;
//    flags    : word;
//    desc     : array[0..39] of char;
  h.gmv := 'Gens Movie TEST';

  a := getheader(data,'Version');
  if a >= 0 then
    h.ver := data.header[a].Idata
  else
    h.ver := 1;

//    rerecs   : longword;
  a := getheader(data,'Rerecordings');
  if a >= 0 then
    h.rerecs := data.header[a].Idata
  else
    h.rerecs := 0;

//    contrnum : byte;
  a := getheader(data,'Special Flags');
  if a >= 0 then
    h.flags := data.header[a].Idata
  else
    h.flags := 0;

//    pc     : array[0..1] of char;
  a := getheader(data,'Player 1 mode (3/6)');
  if a >= 0 then
    strcopy(@h.pc[0],data.header[a].Sdata)
  else
    h.pc[0] := '6';
  a := getheader(data,'Player 2 mode (3/6)');
  if a >= 0 then
    strcopy(@h.pc[1],data.header[a].Sdata)
  else
    h.pc[1] := '6';

//    desc     : array[0..255] of char;
  a := getheader(data,'Description');
  if a >= 0 then
    strcopy(@h.desc,data.header[a].Sdata)
  else
    h.desc := '';

  blockwrite(f,h,sizeof(h));
  //movie
  setlength(cdata,data.frames+1);
  for a := 0 to data.frames do
  begin
    cdata[a,0] := data.controller[0].data[a] and $ff;
    cdata[a,1] := data.controller[1].data[a] and $ff;
    cdata[a,2] := (data.controller[1].data[a] and $f00) shr 4 + (data.controller[0].data[a] and $f00) shr 8;
    cdata[a,0] := $ff xor cdata[a,0];
    cdata[a,1] := $ff xor cdata[a,1];
    cdata[a,2] := $ff xor cdata[a,2];
  end;
  blockwrite(f,cdata[0],(data.frames+1)*3);
  close(f);//}
end;

Procedure GetCodes (s : PChar);
begin
  strcopy(s,chars);
end;

Procedure CheckHeader(const fn : pchar; var res : boolean);
var
  F : file of char;
  fnn :string;
  h : header;
begin
res := false;
fnn := fn;
assign(f,fnn); reset(f);
if filesize(f) < sizeof(h) then
begin
  close(f); exit;
end;
blockread(f,h,sizeof(h));
if h.gmv <> 'Gens Movie TEST' then
begin
  close(f); exit;
end;
if filesize(f) < $40 then
begin
  close(f); exit;
end;
res := true;
end;

exports GetInfo, LoadMovie, GetCodes, SaveMovie, CheckHeader;

end.
