library SMV;

uses
  Sharemem,
  SysUtils,
  Classes,
  tasmovies;

type
  header = record
    SMV      : array[0..3] of char;
    ver      : longword;
    uid      : longint;
    rerecs   : longword;
    frames   : longword;
    controlf : byte;
    movief   : byte;
    syncf    : byte;
    resf     : byte;
    saves    : longword;
    start    : longword;
  end;

{$R *.res}

const
  chars='1234RLXA><v^SsYB';
//  chars='xxxxyyyyRL123456';

Procedure GetInfo (ext, desc : pchar);
begin
  strcopy(ext,'smv');
  strcopy(desc,'Snes9x movie (beta)');
end;

Procedure LoadMovie (var data: TMovie; const fn: pchar; res:pchar);
var
  F : file of char;
  fnn :string;
  s,nam : string;
  h : header;
  n : integer;
  cdata : array of word;
begin
data.error := 1;
getmem(data.filename, strlen(fn)+1);
strcopy(data.filename,fn);
data.headers := 0;
data.frames := 0;
data.datastart := 0;
data.controllers := 0;
data.fragments := 0;
setlength(data.header,0);
setlength(data.controller,0);
setlength(data.fragment,0);
//let's go
data.controllers := 1;
fnn := fn;
assign(f,fnn); reset(f);
if filesize(f) < 32 then
begin
  strcopy(res,'Too small file'#0);
  close(f); exit;
end;
blockread(f,h,32);
if h.SMV <> 'SMV'#$1a then
begin
  strcopy(res,'Wrong header');
  close(f); exit;
end;
data.headers := 12;
setlength(data.header,data.headers);
//    VBM      : array[0..3] of char;
n := 0;
getmem(data.header[0].name,7);
strcopy(data.header[0].name, 'header'#0);
getmem(data.header[0].sdata,5);
strcopy(data.header[0].sdata, pchar(string(h.SMV)+#0));
data.header[0].tp := 3;
data.header[0].l := 4;
data.header[0].Idata := 0;
//    ver      : longword;
inc(n); nam := 'Version';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.ver);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 0;
data.header[n].l := 4;
data.header[n].Idata := h.ver;
//    uid      : longint;
inc(n); nam := 'UID';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.uid);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.uid;
//    frames   : longword;
inc(n); nam := 'Frames';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.frames);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.frames;
//    rerecs   : longword;
inc(n); nam := 'Rerecordings';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.rerecs);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.rerecs;
//    savef    : byte;
inc(n); nam := 'Movie flags';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.movief);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 2;
data.header[n].l := 1;
data.header[n].Idata := h.movief;
//    controlf : byte;
inc(n); nam := 'Controller flags';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.controlf);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 2;
data.header[n].l := 1;
data.header[n].Idata := h.controlf;
//    systemf  : byte;
inc(n); nam := 'Sync flags';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.syncf);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 2;
data.header[n].l := 1;
data.header[n].Idata := h.syncf;
//    emuf     : byte;
inc(n); nam := 'Res flags';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.resf);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 2;
data.header[n].l := 1;
data.header[n].Idata := h.resf;
//    savestate: longword;
inc(n); nam := 'Save state start';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.saves);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.saves;
//    start    : longword;
inc(n); nam := 'Data start';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.start);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.start;
//    code
inc(n); nam := 'Controller Codes';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := chars;
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 3;
data.header[n].l := length(s);
// header is ready...
//data.frames := (filesize(f)-h.start)div 2-1;
data.frames := h.frames;
data.datastart := h.start;
data.fragments := 2;
setlength(data.fragment,2);
data.fragment[0].start := $20;
data.fragment[0].size := data.datastart-$20;
getmem(data.fragment[0].name,12);
strcopy(data.fragment[0].name,'smvsavedata');
setlength(data.fragment[0].data,data.fragment[0].size);
blockread(f,data.fragment[0].data[0],data.fragment[0].size);
// on for movie
//getmem(data.controller,sizeof(data.controller[0]));
//getmem(data.controller[0].data,(data.frames+1)*4);
setlength(data.controller,1);
setlength(data.controller[0].data,(data.frames+1));
setlength(cdata,data.frames+1);
blockread(f,cdata[0],(data.frames+1)*2);
for n := 0 to data.frames do data.controller[0].data[n] := cdata[n];
//freemem(cdata);
data.fragment[1].start := filepos(f);
data.fragment[1].size := filesize(f)-filepos(f);
getmem(data.fragment[1].name,12);
strcopy(data.fragment[1].name,'smvlostdata');
setlength(data.fragment[1].data,data.fragment[1].size);
blockread(f,data.fragment[1].data[0],data.fragment[1].size);
close(f);
data.error := 0;
end;

Procedure SaveMovie (const data: TMovie; const fn: pchar; res:pchar);
var
  f : file of byte;
  fnn : string;
  cdata : array of word;
  a : integer;
  h : header;
begin
  fillchar(h,32,0);
  fnn := fn;
  assign(f,fnn); rewrite(f);
  //header
  h.SMV := 'SMV'#$1a;

  a := getheader(data,'Version');
  if a >= 0 then
    h.ver := data.header[a].Idata
  else
    h.ver := 1;

//    uid      : longint;
  a := getheader(data,'UID');
  if a >= 0 then
    h.UID := data.header[a].Idata
  else
    h.UID := 0;

//    frames   : longword;
  h.frames := data.frames;

//    rerecs   : longword;
  a := getheader(data,'Rerecordings');
  if a >= 0 then
    h.rerecs := data.header[a].Idata
  else
    h.rerecs := 0;

//    savef    : byte;
  a := getheader(data,'Movie flags');
  if a >= 0 then
    h.movief := data.header[a].Idata
  else
    h.movief := 1;

//    controlf : byte;
  a := getheader(data,'Controller flags');
  if a >= 0 then
    h.controlf := data.header[a].Idata
  else
    h.controlf := 1;

//    systemf  : byte;1
  a := getheader(data,'Sync flags');
  if a >= 0 then
    h.syncf := data.header[a].Idata
  else
    h.syncf := 0;

//    emuf     : byte;16
  a := getheader(data,'Res flags');
  if a >= 0 then
    h.resf := data.header[a].Idata
  else
    h.resf := 65;

//    saves    : longword;
  a := getheader(data,'save state start');
  if a >= 0 then
    h.saves := data.header[a].Idata
  else
    h.saves := 0;

//    start    : longword;
  h.start := $20;
  a := getfragment(data,'smvsavedata');
  if a > -1 then
    h.start := h.start + data.fragment[a].size;

  blockwrite(f,h,32);
  //savedata
  a := getfragment(data,'smvsavedata');
  if a > -1 then
  blockwrite(f,data.fragment[a].data[0],data.fragment[a].size) else
  blockwrite(f,#00#00,2);
  //movie
  setlength(cdata,data.frames+1);
  for a := 0 to data.frames do
    cdata[a] := data.controller[0].data[a];
  blockwrite(f,cdata[0],(data.frames+1)*2);
  a := getfragment(data,'smvlostdata');
  if a > -1 then
  blockwrite(f,data.fragment[a].data[0],data.fragment[a].size);
  close(f);
end;

Procedure GetCodes (s : PChar);
begin
  strcopy(s,chars);
end;

Procedure CheckHeader(const fn : pchar; var res : boolean);
var
  F : file of char;
  fnn :string;
  h : header;
begin
res := false;
fnn := fn;
assign(f,fnn); reset(f);
if filesize(f) < 32 then
begin
  close(f); exit;
end;
blockread(f,h,32);
if h.SMV <> 'SMV'#$1a then
begin
  close(f); exit;
end;
if filesize(f) < h.start + 2 + h.frames*2 then
begin
  close(f); exit;
end;
res := true;
end;

exports GetInfo, LoadMovie, GetCodes, SaveMovie, CheckHeader;

end.
