library SRT;

uses
  Sharemem,
  SysUtils,
  Classes,
//  qdialogs,
  tasmovies;

{$R *.res}

const
  chars='0123456789abcdefghijklmonpqrstuv';
  typ='uifs';

Procedure GetInfo (ext, desc : pchar);
begin
  strcopy(ext,'SRT');
  strcopy(desc,'Export to SRT (beta)');
end;

Procedure LoadMovie (var data: TMovie; const fn: pchar; res:pchar);
begin
  data.error := 1;
end;

Procedure SaveMovie (const data: TMovie; const fn: pchar; res:pchar);
var
  fnn : string;
  a,b,d,e,dx : integer;
  x,y,z,l,sx,sl,s0,sn : longword;
  fps:double;
  s : string;
function tts(x : double) : string;
var t : double;
begin
  t := x / fps;
  result := inttostr(trunc(t / 3600)) + ':';
  while length(result) < 3 do result := '0' + result;
  while t >= 3600 do t := t - 3600;
  result := result + inttostr(trunc(t / 60)) + ':';
  while length(result) < 6 do insert('0',result,4);
  while t >= 60 do t := t - 60;
  result := result + inttostr(trunc(t)) + ',';
  while length(result) < 9 do insert('0',result,7);
  while t > 1 do t := t - 1;
  t := t * 1000;
  result := result + inttostr(trunc(t));
  while length(result) < 12 do insert('0',result,10);
end;
begin
  fnn := fn;
  assign(output,fnn); rewrite(output);
  fps := 60;//inputbox('Enter number of frames per second:','FPS',60.0,0,200,1);
  dx := 0;//inputbox('Enter number of frames before actual movie start in AVI:','Frame shift',0,0,1048576,1);
  a := getheader(data,'controller codes');
  if a = -1 then
    s := chars
  else
    s := data.header[a].Sdata + #0;
  s0 := 0;
  sx := dx;
  sn := 0;
  sl := 0;
  for b := 0 to data.frames do
  begin
    if s0 = data.controller[0].data[b] then
    begin
      inc(sl);
      if b <> data.frames then continue;
    end;
//    if s0 <> 0 then
    begin
      inc(sn);
      writeln(sn);
      writeln(tts(sx),' --> ',tts(sx+sl-0.5));
      x := 1;
      z := 0;
      y := s0;
      e := 0;
      for d := 1 to length(s)-1 do
      begin
        inc(e);
        if s[d] = s[d+1] then
          x := (x shl 1) or x
        else
        begin
          l := shortint((y and x) shr z);
          if e = 1 then
          if l = 1 then write(s[d],' ') else write('_ ');
          if e > 1 then
            write(s[d],'=',shortint(l):4,' ');
          x := 1 shl (d);
          z := d;
          e := 0;
        end;
      end;
      sl := 1;
      sx := b+dx;
    end;
    s0 := data.controller[0].data[b];
    writeln;
    writeln;
  end;
  close(output);
end;

Procedure GetCodes (s : PChar);
begin
  strcopy(s,chars);
end;

Procedure CheckHeader(const fn : pchar; var res : boolean);
begin
res := false;
end;

exports GetInfo, LoadMovie, GetCodes, SaveMovie, CheckHeader;

end.
