library TXT;

uses
  Sharemem,
  SysUtils,
  Classes,
  tasmovies;

{$R *.res}

const
  chars='0123456789abcdefghijklmonpqrstuv';
  typ='uifs';

Procedure GetInfo (ext, desc : pchar);
begin
  strcopy(ext,'TXT');
  strcopy(desc,'TAS movie editor text file (beta)');
end;

Procedure LoadMovie (var data: TMovie; const fn: pchar; res:pchar);
var
  fnn : string;
  a,b,d : integer;
  s,s1 : string;
  l,x,y,t,n : longword;
  c : char;
  gc : string;
begin
  getmem(res,1);
  strcopy(res,#0);
  getmem(data.filename, strlen(fn)+1);
  strcopy(data.filename,fn);
  data.headers := 0;
  data.frames := 0;
  data.datastart := 0;
  data.controllers := 0;
  data.fragments := 0;
  setlength(data.header,0);
  setlength(data.controller,0);
  setlength(data.fragment,0);
  fnn:= fn;
  data.error := 1;
  assign(input,fnn); reset(input);
  if filesize(input) = 0 then exit;
  readln(s);
  if lowercase(copy(s,1,8)) <> 'tasmovie' then exit;
  repeat
  readln(s);
  until eof or (lowercase(copy(s,1,8))='[header]');
  if eof then exit;
  repeat
    readln(s); if copy(s,1,2) = '//' then continue;
    if (lowercase(copy(s,1,11))='[fragments]') then break;
    inc(data.headers);
  until eof or (lowercase(copy(s,1,11))='[fragments]');
  if eof then exit;
  repeat
    readln(s); if copy(s,1,2) = '//' then continue;
    if (lowercase(copy(s,1,7))='[data0]') then break;
      delete(s,pos('//',s),length(s));
    inc(data.fragments);
  until eof or (lowercase(copy(s,1,7))='[data0]');
  if eof then exit;
  a := 0;
  repeat
  b := 0;
  repeat
    readln(s); if copy(s,1,2) = '//' then continue;
    if lowercase(copy(s,1,7+ord(a>8)))='[data'+inttostr(a+1)+']' then break;
    if pos('|',s) > 0 then delete(s,1,pos('|',s));
    if pos('//',s) > 0 then delete(s,pos('//',s),length(s));
    s := s + ' ';
    if pos(':',s)>0 then
      begin
        delete(s,1,pos(':',s));
        s := copy(s,1,pos(' ',s)-1);
        inc(b,strtoint(s)-1);
      end;
    inc(b);
  until eof or (lowercase(copy(s,1,7+ord(a>8)))='[data'+inttostr(a+1)+']');
  if b-1 > data.frames then data.frames := b-1;
  inc(a);
  until eof;
  data.controllers := a;
  setlength(data.header,data.headers);
  setlength(data.fragment,data.fragments);
  setlength(data.controller,data.controllers);
//  getmem(data.controller,sizeof(data.controller[0])*data.controllers);
//  for a := 0 to data.controllers do
//    getmem(data.controller[a].data,(data.frames+1)*4);
  for a := 0 to data.controllers -1 do setlength(data.controller[a].data,data.frames+1);
  reset(input);
  repeat
    readln(s);
  until eof or (lowercase(copy(s,1,8))='[header]');
  if eof then exit;
  a := 0;
  repeat
    readln(s); if copy(s,1,2) = '//' then continue;
    if (lowercase(copy(s,1,11))='[fragments]') then break;
    //interpret header
    if pos('//',s) > 0 then
      delete(s,pos('//',s),length(s));
    s1 := copy(s,1,pos('|',s)-1);
    delete(s,1,length(s1)+1);
    c := s[1];
    delete(s,1,1);
    d := strtoint('0'+copy(s,1,pos('=',s)-1));
    delete(s,1,pos('=',s));
    getmem(data.header[a].name,length(s1)+1);
    strcopy(data.header[a].name,pchar(s1+#0));
    data.header[a].tp := pos(c,typ)-1;
    case c of
      'i','u','f' : begin
      data.header[a].Idata := strtoint(s);
      getmem(data.header[a].Sdata,length(s)+1);
      strcopy(data.header[a].Sdata,pchar(s+#0));
      data.header[a].l := d;
      end;
      's' : begin
      while copy(s,length(s),1) = ' ' do delete(s,length(s),1);
      data.header[a].l := length(s);
      getmem(data.header[a].Sdata,length(s)+1);
      strcopy(data.header[a].Sdata,pchar(s+#0));
      end;
    end;
    inc(a);
  until eof or (lowercase(copy(s,1,11))='[fragments]');
  if eof then exit;
  a := getheader(data,'frames');
  if a > 0 then data.header[a].Idata := data.frames;
  a := getheader(data,'controller codes');
  if a > 0 then gc := data.header[a].Sdata
    else gc := chars;
  a := 0;
  repeat
    readln(s); if copy(s,1,2) = '//' then continue;
    if (lowercase(copy(s,1,7))='[data0]') then break;
    s1 := copy(s,1,pos('|',s)-1);
    delete(s,1,length(s1)+1);
    d := strtoint('0'+copy(s,1,pos('=',s)-1));
    delete(s,1,pos('=',s));
    getmem(data.fragment[a].name,length(s1)+1);
    strcopy(data.fragment[a].name,pchar(s1+#0));
    data.fragment[a].start := d;
    data.fragment[a].size := length(s) div 2;
//    getmem(data.fragment[a].data,data.fragment[a].size);
    setlength(data.fragment[a].data, length(s) div 2);
    for b := 0 to data.fragment[a].size-1 do
    begin
      d := ord(s[b*2+1]) - $30 - $7 * ord(s[b*2+1] > '9');
      d := (d shl 4) or (ord(s[b*2+2]) - $30 - $7 * ord(s[b*2+2] > '9'));
      data.fragment[a].data[b] := byte(d);
    end;
    inc(a);
  until eof or (lowercase(copy(s,1,7))='[data0]');
  if eof then exit;
  a := 0;
  repeat
  b := 0;
  repeat
    readln(s); if copy(s,1,2) = '//' then continue;
    if lowercase(copy(s,1,7+ord(a>8)))='[data'+inttostr(a+1)+']' then break;
    //interpret controls
    if pos('|',s) > 0 then delete(s,1,pos('|',s));
    if pos('//',s) > 0 then delete(s,pos('//',s),length(s));
    s := s + ' ';
    t := 0;
    n := 1;
    while length(s) > 1 do
    begin
      if s[1] = ':' then
      begin
        delete(s,1,1);
        s := copy(s,1,pos(' ',s)-1);
        n := strtoint(s);
        break;
      end;
      if pos(s[1],gc) = 0 then
      begin
        delete(s,1,1);
        continue
      end;
      l := 1;
      c := s[1];
      delete(s,1,1);
      if s[1] = '=' then
      begin
        l := strtoint(copy(s,2,pos(' ',s)-2));
        delete(s,1,pos(' ',s));
      end;
      x := 0;
      y := 0;
      for d := length(gc) downto 1do
      begin
        x := x shl 1;
        inc(y);
        if gc[d] = c then
        begin
          x := x or 1;
          y := 0;
        end;
      end;
      l := l shl y and x;
      t := t or l;
    end;
    repeat
    data.controller[a].data[b] := t;
    inc(b);
    dec(n);
    until n = 0;
  until eof or (lowercase(copy(s,1,7+ord(a>8)))='[data'+inttostr(a+1)+']');
  inc(a);
  until eof;
  data.error := 0;
  close(input);
end;

Procedure SaveMovie (const data: TMovie; const fn: pchar; res:pchar);
var
  fnn : string;
  a,b,d,e : integer;
  x,y,z,l : longword;
  s : string;
begin
  fnn := fn;
  assign(output,fnn); rewrite(output);
  writeln('TASmovie');
  writeln('[header]');
  for a := 0 to data.headers-1 do
  begin
    if data.header[a].tp = 3 then
      writeln(data.header[a].name,'|s',data.header[a].l,'=',data.header[a].SData)
    else
      writeln(data.header[a].name,'|',typ[data.header[a].tp+1],data.header[a].l,'=',data.header[a].IData);
  end;
  writeln('[fragments]');
  for a := 0 to data.fragments-1 do
  begin
    write(data.fragment[a].name,'|',data.fragment[a].start,'=');
    for b := 0 to data.fragment[a].size-1 do write(inttohex(data.fragment[a].data[b],2));
    writeln;
  end;
  a := getheader(data,'controller codes');
  if a = -1 then
    s := chars
  else
    s := data.header[a].Sdata + #0;
  for a := 0 to data.controllers-1 do
  begin
    writeln('[data',a,']');
    for b := 0 to data.frames do
    begin
      write(b:10,'|');
      x := 1;
      z := 0;
      y := data.controller[a].data[b];
      e := 0;
      for d := 1 to length(s)-1 do
      begin
        inc(e);
        if s[d] = s[d+1] then
          x := (x shl 1) or x
        else
        begin
          l := shortint((y and x) shr z);
          if e = 1 then
          if l = 1 then write(s[d]);
          if e > 1 then
            if l > 0 then
              write(s[d],'=',shortint(l),' ');
          x := 1 shl (d);
          z := d;
          e := 0;
        end;
      end;
      writeln;
    end;
  end;
  close(output);
end;

Procedure GetCodes (s : PChar);
begin
  strcopy(s,chars);
end;

Procedure CheckHeader(const fn : pchar; var res : boolean);
var fnn : string;
f : file of char;
tst : array[0..7] of char;
begin
res := false;
fnn := fn;
assign(f,fnn);
reset(f);
if filesize(f) < 8 then
begin
close(f);
exit;
end;
blockread(f,tst,8);
if lowercase(tst) = 'tasmovie' then res := true;
close(f);
end;

exports GetInfo, LoadMovie, GetCodes, SaveMovie, CheckHeader;

end.
