library VBM;

uses
  Sharemem,
  SysUtils,
  Classes,
  tasmovies;

type
  header = record
    VBM      : array[0..3] of char;
    ver      : longword;
    uid      : longint;
    frames   : longword;
    rerecs   : longword;
    savef    : byte;
    controlf : byte;
    systemf  : byte;
    emuf     : byte;
    savetype : longword;
    flashsize: longword;
    emutype  : longword;
    gamename : array[0..11] of char;
    null     : byte;
    romcrc   : byte;
    CRC16    : word;
    gamecode : longword;
    savestate: longword;
    start    : longword;
    author   : array[0..63] of char;
    desc     : array[0..127] of char;
  end;

{$R *.res}

const
  chars='ABsS><^vRL123456';
//  chars='xxxxyyyyRL123456';

Procedure GetInfo (ext, desc : pchar);
begin
  strcopy(ext,'vbm');
  strcopy(desc,'VisualBoy Advance movie (beta)');
end;

Procedure LoadMovie (var data: TMovie; const fn: pchar; res:pchar);
var
  F : file of char;
  fnn :string;
  s,nam : string;
  h : header;
  n : integer;
  cdata : array of word;
begin
data.error := 1;
getmem(data.filename, strlen(fn)+1);
strcopy(data.filename,pchar(fn+#0));
data.headers := 0;
data.frames := 0;
data.datastart := 0;
data.controllers := 0;
data.fragments := 0;
setlength(data.header,0);
setlength(data.controller,0);
setlength(data.fragment,0);
//let's go
data.controllers := 1;
fnn := fn;
assign(f,fnn); reset(f);
if filesize(f) < 256 then
begin
  strcopy(res,'Too small file');
  close(f); exit;
end;
blockread(f,h,256);
if h.VBM <> 'VBM'#$1a then
begin
  strcopy(res,'Wrong header');
  close(f); exit;
end;
data.headers := 22;
setlength(data.header,data.headers);
//    VBM      : array[0..3] of char;
n := 0;
getmem(data.header[0].name,7);
strcopy(data.header[0].name, 'header'#0);
getmem(data.header[0].sdata,5);
strcopy(data.header[0].sdata, pchar(string(h.VBM)+#0));
data.header[0].tp := 3;
data.header[0].l := 4;
data.header[0].Idata := 0;
//    ver      : longword;
inc(n); nam := 'Version';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.ver);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 0;
data.header[n].l := 4;
data.header[n].Idata := h.ver;
//    uid      : longint;
inc(n); nam := 'UID';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.uid);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.uid;
//    frames   : longword;
inc(n); nam := 'Frames';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.frames);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.frames;
//    rerecs   : longword;
inc(n); nam := 'Rerecordings';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.rerecs);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.rerecs;
//    savef    : byte;
inc(n); nam := 'Save flags';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.savef);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 2;
data.header[n].l := 1;
data.header[n].Idata := h.savef;
//    controlf : byte;
inc(n); nam := 'Controller flags';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.controlf);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 2;
data.header[n].l := 1;
data.header[n].Idata := h.controlf;
//    systemf  : byte;
inc(n); nam := 'System flags';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.systemf);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 2;
data.header[n].l := 1;
data.header[n].Idata := h.systemf;
//    emuf     : byte;
inc(n); nam := 'Emulator flags';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.emuf);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 2;
data.header[n].l := 1;
data.header[n].Idata := h.emuf;
//    savetype : longword;
inc(n); nam := 'Save type';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.savetype);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.savetype;
//    flashsize: longword;
inc(n); nam := 'Flash size';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.Flashsize);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.flashsize;
//    emutype  : longword;
inc(n); nam := 'Emulator type';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.emutype);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.emutype;
//    gamename : array[0..11] of char;
inc(n); nam := 'Game Name';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := h.gamename;
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 3;
data.header[n].l := length(s);
//    null     : byte;
inc(n); nam := 'Null';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.null);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 1;
data.header[n].Idata := h.null;
//    romcrc   : byte;
inc(n); nam := 'Rom CRC';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.romcrc);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 1;
data.header[n].Idata := h.romcrc;
//    CRC16    : word;
inc(n); nam := 'CRC16';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.crc16);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 2;
data.header[n].Idata := h.crc16;
//    gamecode : longword;
inc(n); nam := 'Game code';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.gamecode);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.gamecode;
//    savestate: longword;
inc(n); nam := 'Save state start';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.savestate);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.savestate;
//    start    : longword;
inc(n); nam := 'Data start';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := inttostr(h.start);
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 1;
data.header[n].l := 4;
data.header[n].Idata := h.start;
//    author   : array[0..63] of char;
inc(n); nam := 'Movie Author';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := h.author;
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 3;
data.header[n].l := length(s);
//    desc     : array[0..127] of char;}
inc(n); nam := 'Movie description';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := h.desc;
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 3;
data.header[n].l := length(s);
//    code
inc(n); nam := 'Controller Codes';
getmem(data.header[n].name,length(nam)+1);
strcopy(data.header[n].name,pchar(nam+#0));
s := chars;
getmem(data.header[n].sdata,length(s)+1);
strcopy(data.header[n].sdata, pchar(s+#0));
data.header[n].tp := 3;
data.header[n].l := length(s);
// header is ready...
data.frames := h.frames;
data.datastart := h.start;
data.fragments := 1;
setlength(data.fragment,1);
data.fragment[0].start := 256;
data.fragment[0].size := data.datastart-256;
getmem(data.fragment[0].name,12);
strcopy(data.fragment[0].name,'vbasavedata'#0);
setlength(data.fragment[0].data,data.fragment[0].size);
blockread(f,data.fragment[0].data[0],data.fragment[0].size);
// on for movie
//getmem(data.controller,sizeof(data.controller[0]));
//getmem(data.controller[0].data,(data.frames+1)*4);
setlength(data.controller,1);
setlength(data.controller[0].data,(data.frames+1));
setlength(cdata,data.frames+1);
blockread(f,cdata[0],(data.frames+1)*2);
for n := 0 to data.frames do data.controller[0].data[n] := cdata[n];
//freemem(cdata);
close(f);
data.error := 0;
end;

Procedure SaveMovie (const data: TMovie; const fn: pchar; res:pchar);
var
  f : file of byte;
  fnn : string;
  cdata : array of word;
  a : integer;
  h : header;
begin
  fillchar(h,256,0);
  fnn := fn;
  assign(f,fnn); rewrite(f);
  //header
  h.VBM := 'VBM'#$1a;

  a := getheader(data,'Version');
  if a >= 0 then
    h.ver := data.header[a].Idata
  else
    h.ver := 1;

//    uid      : longint;
  a := getheader(data,'UID');
  if a >= 0 then
    h.UID := data.header[a].Idata
  else
    h.UID := 0;

//    frames   : longword;
  h.frames := data.frames;

//    rerecs   : longword;
  a := getheader(data,'Rerecordings');
  if a >= 0 then
    h.rerecs := data.header[a].Idata
  else
    h.rerecs := 0;

//    savef    : byte;
  a := getheader(data,'Save flags');
  if a >= 0 then
    h.savef := data.header[a].Idata
  else
    h.savef := 0;

//    controlf : byte;
  a := getheader(data,'Controller flags');
  if a >= 0 then
    h.controlf := data.header[a].Idata
  else
    h.controlf := 1;

//    systemf  : byte;1
  a := getheader(data,'System flags');
  if a >= 0 then
    h.systemf := data.header[a].Idata
  else
    h.systemf := 1;

//    emuf     : byte;16
  a := getheader(data,'Emulator flags');
  if a >= 0 then
    h.emuf := data.header[a].Idata
  else
    h.emuf := 16;

//    savetype : longword;
  a := getheader(data,'Save type');
  if a >= 0 then
    h.savetype := data.header[a].Idata
  else
    h.savetype := 1;

//    flashsize: longword;
  a := getheader(data,'Flash size');
  if a >= 0 then
    h.flashsize := data.header[a].Idata
  else
    h.flashsize := 1;

//    emutype  : longword;
  a := getheader(data,'Emulator type');
  if a >= 0 then
    h.emutype := data.header[a].Idata
  else
    h.emutype := 1;

//    gamename : array[0..11] of char;
  a := getheader(data,'Game Name');
  if a >= 0 then
    strcopy(@h.gamename,data.header[a].Sdata)
  else
    h.gamename  := '';

//    null     : byte;
  a := getheader(data,'Null');
  if a >= 0 then
    h.null := data.header[a].Idata
  else
    h.null := 1;

//    romcrc   : byte;
  a := getheader(data,'Rom CRC');
  if a >= 0 then
    h.romcrc := data.header[a].Idata
  else
    h.romcrc := 0;

//    CRC16    : word;
  a := getheader(data,'CRC16');
  if a >= 0 then
    h.CRC16 := data.header[a].Idata
  else
    h.CRC16 := 1;

//    gamecode : longword;
  a := getheader(data,'Game code');
  if a >= 0 then
    h.gamecode := data.header[a].Idata
  else
    h.gamecode := 0;

//    savestate: longword;
  a := getheader(data,'Save state start');
  if a >= 0 then
    h.savestate := data.header[a].Idata
  else
    h.savestate := $100;

//    start    : longword;
  h.start := $100;
  a := getfragment(data,'vbasavedata');
  if a > -1 then
    h.start := h.start + data.fragment[a].size;

//    author   : array[0..63] of char;
  a := getheader(data,'Movie Author');
  if a >= 0 then
    strcopy(@h.author,data.header[a].Sdata)
  else
    h.author := '';

//    desc     : array[0..127] of char;
  a := getheader(data,'Movie Description');
  if a >= 0 then
    strcopy(@h.desc,data.header[a].Sdata)
  else
    h.desc  := '';


  blockwrite(f,h,256);
  //savedata
  a := getfragment(data,'vbasavedata');
  if a > -1 then
  blockwrite(f,data.fragment[a].data[0],data.fragment[a].size) else
  blockwrite(f,#00#00,2);
  //movie
  setlength(cdata,data.frames+1);
  for a := 0 to data.frames do
    cdata[a] := data.controller[0].data[a];
  blockwrite(f,cdata[0],(data.frames+1)*2);
  close(f);
end;

Procedure GetCodes (s : PChar);
begin
  strcopy(s,chars);
end;

Procedure CheckHeader(const fn : pchar; var res : boolean);
var
  F : file of char;
  fnn :string;
  h : header;
begin
res := false;
fnn := fn;
assign(f,fnn); reset(f);
if filesize(f) < 256 then
begin
  close(f); exit;
end;
blockread(f,h,256);
if h.VBM <> 'VBM'#$1a then
begin
  close(f); exit;
end;
if filesize(f) < h.start + 2 + h.frames*2 then
begin
  close(f); exit;
end;
res := true;
end;

exports GetInfo, LoadMovie, GetCodes, SaveMovie, CheckHeader;

end.
